
        .386
        .MODEL FLAT

        include winbase.inc
        include except.inc
        include macros.inc


VDDInstallMemoryHook proto stdcall :DWORD, :DWORD, :DWORD, :DWORD
getEBX  proto stdcall
getECX  proto stdcall

        .data

hVDD    DWORD 0
dwOldExcFilter DWORD 0

g_er    EXCEPTION_REGISTRATION <0, offset except_handler,0,0>

        .code

except_handler proc c uses ebx esi edi pReport:ptr EXCEPTION_RECORD,\
                            pFrame:ptr FRAME,\
                            pContext:ptr CONTEXT,\
                            pContDisp:ptr CONTEXT

    	invoke  OutputDebugString, CStr(<"except_handler called",13,10>)
    	mov eax,_XCPT_CONTINUE_SEARCH
    	ret
except_handler endp

MyExcFilter proc stdcall pExceptionInfo:ptr EXCEPTION_POINTERS
    	invoke  OutputDebugString, CStr(<"Unhandled Exception Filter called",13,10>)
		mov eax, EXCEPTION_CONTINUE_SEARCH
		ret	
MyExcFilter endp

        assume fs:nothing

;--- Init

Init    proc    stdcall

local   szText[128]:byte

		invoke SetUnhandledExceptionFilter, offset MyExcFilter
        mov dwOldExcFilter, eax

		mov eax, fs:[0]
        .while (eax != -1)
        	push eax
	        mov ecx, [eax+4]
    	    invoke wsprintf, addr szText, CStr(<"exception handler %X %X",13,10>), eax, ecx
        	invoke  OutputDebugString, addr szText
            pop eax
;            mov [eax+4],offset except_handler
            mov eax,[eax]
        .endw
       	invoke  OutputDebugString, CStr(<"----",13,10>)
        ret
Init    endp

;--- Dispatch

Dispatch    proc    stdcall uses ebx

local   hThread:DWORD
local   szText[128]:byte

        invoke GetCurrentThread
        mov hThread, eax
        mov ecx, fs:[0]
        invoke wsprintf, addr szText,\
            CStr(<"Dispatch called, exception handler=%X",13,10>),\
            [ecx.EXCEPTION_REGISTRATION.ExceptionHandler]
        invoke  OutputDebugString, addr szText
        ret
Dispatch    endp

;*** main proc ***

DllMain proc stdcall hInstance:dword,reason:dword,reserved:dword

        mov eax, reason
        .if (eax == DLL_PROCESS_ATTACH)
            mov eax, hInstance
            mov hVDD, eax
            invoke  OutputDebugString, CStr(<"debxxvdd process attach",13,10>)
        .elseif (eax == DLL_PROCESS_DETACH)
            invoke  OutputDebugString, CStr(<"debxxvdd process detach",13,10>)
        .elseif (eax == DLL_THREAD_ATTACH)
            invoke  OutputDebugString, CStr(<"debxxvdd thread attach",13,10>)
        .elseif (eax == DLL_THREAD_DETACH)
            invoke  OutputDebugString, CStr(<"debxxvdd thread detach",13,10>)
        .endif
        mov     eax,1
        ret
DllMain endp

        END DllMain

